/* Special characters above ensure UTF-8 encoding in VisualStudio.  */
/** 
@file         \$Source: $
@copyright    (c) Rohde & Schwarz GmbH & Co. KG, Munich
@version      \$Revision: \main\integration_fps_0.10_1.80_39\2 $
*
@author       %USERNAME%
@responsible  \$Author: fsw_inte $
*
@language     C++
*
@description  
@see          
*
@history
*******************************************************************************
******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>


#ifdef _WIN32
# define WIN_LEAN_AND_MEAN
# ifdef _AFXDLL
#   include <afx.h>
# else
#   include <windows.h>
# endif
  typedef HINSTANCE LIBHANDLE;
#else // WIN32
  #define __USE_GNU
  #include <unistd.h>
  #include <dlfcn.h>

  typedef void* LIBHANDLE;
#endif

#include "visaabstraction.h"
#include "SgmaCommandIds.h"

#if defined(__cplusplus) || defined(__cplusplus__)
extern "C" {
#endif

// forward declarations shared library functions
static LIBHANDLE shlOpen(const char* libraryPathname);
static void shlClose(LIBHANDLE handle);
static int shlIsOpen(LIBHANDLE handle);
static void* shlGetProcAddress(LIBHANDLE handle, const char* procName);

#if ( defined(__linux__) && __GNUC__ >= 4 )

typedef ViStatus (*viOpenDefaultRMType)  (ViPSession vi);
typedef ViStatus (*viCloseType)          (ViObject vi);
typedef ViStatus (*viOpenType)           (ViSession sesn, ViRsrc name, ViAccessMode mode, ViUInt32 timeout, ViPSession vi);
typedef ViStatus (*viStatusDescType)     (ViObject vi, ViStatus status, ViChar _VI_FAR desc[]);
typedef ViStatus (*viSetAttributeType)   (ViObject vi, ViAttr attrName, ViAttrState attrValue);
typedef ViStatus (*viGetAttributeType)   (ViObject vi, ViAttr attrName, void _VI_PTR attrValue);
typedef ViStatus (*viWriteType)          (ViSession vi, ViBuf  buf, ViUInt32 cnt, ViPUInt32 retCnt);
typedef ViStatus (*viReadType)           (ViSession vi, ViPBuf buf, ViUInt32 cnt, ViPUInt32 retCnt);
typedef ViStatus (*viReadSTBType)        (ViSession vi, ViPUInt16 status);
typedef ViStatus (*viVPrintfType)        (ViSession vi, ViString writeFmt, ViVAList params);
typedef ViStatus (*viSetBufType)         (ViSession vi, ViUInt16 mask, ViUInt32 size);
typedef ViStatus (*viVScanfType)         (ViSession vi, ViString readFmt, ViVAList params);
typedef ViStatus (*viVQueryfType)        (ViSession vi, ViString writeFmt, ViString readFmt, ViVAList params);
typedef ViStatus (*viClearType)          (ViSession vi);
/* */

typedef ViStatus (*viFastSettingSupportedType) (ViSession vi, ViUInt32 paraId, ViPUInt32 supported);
typedef ViStatus (*viFastSetReal64Type) (ViSession vi, ViUInt32 paraId, ViReal64 value);
typedef ViStatus (*viFastSetInt32Type) (ViSession vi, ViUInt32 paraId, ViInt32 value);
typedef ViStatus (*viFastSetMultipleType) (ViSession vi,  void* paraList, ViInt32 paraListItemCount);
typedef ViStatus (*viFastSendControlMessageType) (ViSession vi,  ViInt32 message);
typedef ViStatus (*viEnumeratePCIeDevicesType) (ViInt32 vendorId, ViInt32 deviceId, ViPInt32 serialNumbers, ViPInt32 serialNumberCount);
typedef ViStatus (*viFastQueryReal64Type) (ViSession vi, ViUInt32 paraId, ViReal64* value);
typedef ViStatus (*viFastQueryInt32Type) (ViSession vi, ViUInt32 paraId, ViInt32* value);
typedef ViStatus (*viFastQuerySupportedType) (ViSession vi, ViUInt32 paraId, ViPUInt32 supported);
typedef ViStatus (*viEnumerateSocketDevicesType) (ViPString *info, ViPInt32 infoCount);

#else

typedef ViStatus (_VI_FUNC *viOpenDefaultRMType)  (ViPSession vi);
typedef ViStatus (_VI_FUNC *viCloseType)          (ViObject vi);
typedef ViStatus (_VI_FUNC *viOpenType)           (ViSession sesn, ViRsrc name, ViAccessMode mode, ViUInt32 timeout, ViPSession vi);
typedef ViStatus (_VI_FUNC *viStatusDescType)     (ViObject vi, ViStatus status, ViChar _VI_FAR desc[]);
typedef ViStatus (_VI_FUNC *viSetAttributeType)   (ViObject vi, ViAttr attrName, ViAttrState attrValue);
typedef ViStatus (_VI_FUNC *viGetAttributeType)   (ViObject vi, ViAttr attrName, void _VI_PTR attrValue);
typedef ViStatus (_VI_FUNC *viWriteType)          (ViSession vi, ViBuf  buf, ViUInt32 cnt, ViPUInt32 retCnt);
typedef ViStatus (_VI_FUNC *viReadType)           (ViSession vi, ViPBuf buf, ViUInt32 cnt, ViPUInt32 retCnt);
typedef ViStatus (_VI_FUNC *viReadSTBType)        (ViSession vi, ViPUInt16 status);
typedef ViStatus (_VI_FUNC *viVPrintfType)        (ViSession vi, ViString writeFmt, ViVAList params);
typedef ViStatus (_VI_FUNC *viSetBufType)         (ViSession vi, ViUInt16 mask, ViUInt32 size);
typedef ViStatus (_VI_FUNC *viVScanfType)         (ViSession vi, ViString readFmt, ViVAList params);
typedef ViStatus (_VI_FUNC *viVQueryfType)        (ViSession vi, ViString writeFmt, ViString readFmt, ViVAList params);
typedef ViStatus (_VI_FUNC *viClearType)          (ViSession vi);
/* */

typedef ViStatus (_VI_FUNC *viFastSettingSupportedType) (ViSession vi, ViUInt32 paraId, ViPUInt32 supported);
typedef ViStatus (_VI_FUNC *viFastSetReal64Type) (ViSession vi, ViUInt32 paraId, ViReal64 value);
typedef ViStatus (_VI_FUNC *viFastSetInt32Type) (ViSession vi, ViUInt32 paraId, ViInt32 value);
typedef ViStatus (_VI_FUNC *viFastSetMultipleType) (ViSession vi,  void* paraList, ViInt32 paraListItemCount);
typedef ViStatus (_VI_FUNC *viFastSendControlMessageType) (ViSession vi,  ViInt32 message);
typedef ViStatus (_VI_FUNC *viEnumeratePCIeDevicesType) (ViInt32 vendorId, ViInt32 deviceId, ViPInt32 serialNumbers, ViPInt32 serialNumberCount);
typedef ViStatus (_VI_FUNC *viFastQueryReal64Type) (ViSession vi, ViUInt32 paraId, ViReal64* value);
typedef ViStatus (_VI_FUNC *viFastQueryInt32Type) (ViSession vi, ViUInt32 paraId, ViInt32* value);
typedef ViStatus (_VI_FUNC *viFastQuerySupportedType) (ViSession vi, ViUInt32 paraId, ViPUInt32 supported);
typedef ViStatus (_VI_FUNC *viEnumerateSocketDevicesType) (ViPString *info, ViPInt32 infoCount);


#endif // ( defined(__linux__) && __GNUC__ >= 4 )

#if defined(__cplusplus) || defined(__cplusplus__)
}
#endif



#define FuncIdOpenDefaultRM           0
#define FuncIdClose                   1
#define FuncIdOpen                    2    
#define FuncIdStatusDesc              3
#define FuncIdSetAttribute            4
#define FuncIdGetAttribute            5
#define FuncIdWrite                   6
#define FuncIdRead                    7
#define FuncIdReadSTB                 8
#define FuncIdVPrintf                 9
#define FuncIdSetBuf                  10
#define FuncIdVScanf                  11
#define FuncIdVQueryf                 12
/* */ 
#define FuncIdFastSettingSupported    13
#define FuncIdFastSetReal64           14
#define FuncIdFastSetInt32            15
#define FuncIdFastSetMultiple         16
#define FuncIdFastSendControlMessage  17
#define FuncIdEnumerateDevices        18
#define FuncIdClear                   19
#define FuncIdFastQueryReal64         20
#define FuncIdFastQueryInt32          21
#define FuncIdFastQuerySupported      22
#define FuncIdEnumerateSocketDevices  23
#define FuncIdCnt                     24 


// -----------------
#define ControlMessageNoop           0
#define ControlMessageSynchronous    1
#define ControlMessageAsynchronous   2
#define ControlMessageSync           3



#define LibIdVisa               0
#define LibIdSocket             1
#define LibIdPCIe               2
#define LibIdCnt                3
static const char* FuncPrefix[LibIdCnt] = {"vi", "sc", "pc"};
LIBHANDLE RemoteControlLibrary[LibIdCnt] = {0};
long      ReferenceCount [LibIdCnt] = {0};


#ifdef __linux__
 static char* RemoteControlLibraryName[LibIdCnt] = {"/usr/local/lib/libvisa.so",
                                                    "libsocketcontroller.so",
                                                    "libpciecontroller.so"};


#else

static char* RemoteControlLibraryName[LibIdCnt] = {"Visa32.dll", 
                                                   "SocketController.dll",
                                                   "PCIeController.dll"
                                                    };

#endif  

static const char* FuncName[FuncIdCnt] = {"OpenDefaultRM", 
                                          "Close",          
                                          "Open",           
                                          "StatusDesc",     
                                          "SetAttribute",   
                                          "GetAttribute",   
                                          "Write",          
                                          "Read",          
                                          "ReadSTB",        
                                          "VPrintf",        
                                          "SetBuf",         
                                          "VScanf",         
                                          "VQueryf",
                                          "FastSettingSupported",
                                          "FastSetReal64",
                                          "FastSetInt32",
                                          "FastSetMultiple",
                                          "FastSendControlMessage",
                                          "EnumeratePCIeDevices",
                                          "Clear",
                                          "FastQueryReal64",
                                          "FastQueryInt32",
                                          "FastQuerySupported",
                                          "EnumerateSocketDevices",
                                          };        
static void* FunctionPointers[LibIdCnt][FuncIdCnt];


#define TypeResource 98723
#define TypeDevice   78233

typedef struct  
{
  int   Type; 
  int   LibId;
  int   Data;
  int   IntfId;
}StrctResource;


typedef struct  
{
  int           Type; 
  ViObject      Device;
  unsigned int  UserData;
  unsigned int  EnableFastSettings;
  unsigned int  EnableAsyncSettings;
  unsigned int  LastSettingWasFast;
  int           ResourceHandle;
}StrctDevice;


#define MAXHANDLES 100
void* g_DeviceList[MAXHANDLES] = {0};


static int FindNextFreeEntry()
{
  int i = 1;
  for (i = 1; i < MAXHANDLES; i++)
  {
    if (g_DeviceList[i] == 0)
      return i;
  }
  return -1;
}

static int IsResourceHandle(int handle)
{
  return handle & 0x10000;
}

static void RemoveDevice(int handle)
{
  int index = handle & 0xffff;
  g_DeviceList[index] = 0;
}

static StrctDevice* GetDevice(int handle)
{
  if (!IsResourceHandle(handle))
  {
    int index = handle;
    if (index >= 0 && index < MAXHANDLES)
      return (StrctDevice *)(g_DeviceList[index]);
  }  
  return 0;  
}

static int GetDeviceCount(int resourcehandle)
{
  int nDeviceCount = 0;
  int i = 0;
  for (i = 0; i < MAXHANDLES; i++)
  {
    if ((g_DeviceList[i] != 0) && 
        ((StrctDevice*)g_DeviceList[i])->Type == TypeDevice && 
        ((StrctDevice*)g_DeviceList[i])->ResourceHandle == resourcehandle)
        {
          nDeviceCount++;
        }
  }
  return nDeviceCount;
}

static void RemoveResource(int handle)
{
  int index = handle & 0xffff;
  g_DeviceList[index] = 0;
}

static StrctResource* GetResource(int handle)
{
  if (IsResourceHandle(handle))
  {
    int index = handle & 0xffff;
    if (index >= 0 && index < MAXHANDLES)
      return (StrctResource *)(g_DeviceList[index]);
  }
  return 0;  
}


static int AddDevice(StrctDevice* pDevice)
{
  int index = FindNextFreeEntry();
  if (index < 0)
  {
    printf ("Device list full\n");
  }
  else
  {
    if (pDevice)
      pDevice->Type = TypeDevice;
    g_DeviceList[index] = pDevice;
  }
  return index;
}

static int AddResource(StrctResource* pResource)
{
  int index = FindNextFreeEntry();
  if (index < 0)
  {
    printf ("Device list full\n");
    return index;
  }
  else
  {
    if (pResource)
      pResource->Type = TypeResource;
    g_DeviceList[index] = pResource;
    return index | 0x10000;
  }
}

static void SetResource(int handle, StrctResource* pResource)
{
  if (IsResourceHandle(handle))
  {
    int index = handle & 0xffff;
    if (index >= 0 && index < MAXHANDLES)
    {
      g_DeviceList[index] = pResource;
      if (pResource)
        pResource->Type = TypeResource;
    }
  }
}

/*===========================================================================*/
/* Function: viOpenRemoteControlLibrary                                      */
/* Purpose:  Open a remote control library given by its Id                   */
/*===========================================================================*/
static void viOpenRemoteControlLibrary (int nLibraryId)
{
  if (ReferenceCount[nLibraryId] == 0)  
  {
    RemoteControlLibrary[nLibraryId] = shlOpen(RemoteControlLibraryName[nLibraryId]);
    if (shlIsOpen(RemoteControlLibrary[nLibraryId]))  
    {
      char szProcName[256];
      const char* szPrefix = FuncPrefix[nLibraryId];
      int i = 0;

      for (i = 0; i < FuncIdCnt; i++)
      {
        sprintf (szProcName,"%s%s",szPrefix,FuncName[i]);
        FunctionPointers[nLibraryId][i]  = shlGetProcAddress(RemoteControlLibrary[nLibraryId],szProcName);
      }
    }
    ReferenceCount[nLibraryId]++;
  }  
  
}

/*===========================================================================*/
/* Function: viCloseRemoteControlLibrary                                     */
/* Purpose:  Close a remote control library given by its Id                  */
/*===========================================================================*/
static void viCloseRemoteControlLibrary (int nLibraryId)
{
  if (shlIsOpen(RemoteControlLibrary[nLibraryId]) && ReferenceCount[nLibraryId] > 0)
  {
    ReferenceCount[nLibraryId]--;
    if (ReferenceCount[nLibraryId] == 0) 
    {
      int i = 0;
      for (i = 0; i < FuncIdCnt; i++)
      {
        FunctionPointers[nLibraryId][i]  = 0;
      }

      shlClose(RemoteControlLibrary[nLibraryId]);
      RemoteControlLibrary[nLibraryId] = 0;
    }
  }
}


/*===========================================================================*/
/* Function: viOpenDefaultRM                                                 */
/* Purpose:  Interface independent version of function viOpenDefaultRM       */
/*===========================================================================*/
ViStatus _VI_FUNC  rsOpenDefaultRM (ViPSession pSessionDefaultRM)
{
  ViStatus status = VI_ERROR_LIBRARY_NFOUND;

  int i = 0; 
  for (i = 0; i < LibIdCnt; i++)
  {
    viOpenRemoteControlLibrary(i);
    if (RemoteControlLibrary[i])
      status = VI_SUCCESS;    // at least one library could be opened
  }  

  /* we don't know the correct remote control channel before an actual device is opened
     so don't do anything here */ 

  *pSessionDefaultRM = AddResource(0);

  return status;
}

/*===========================================================================*/
/* Function: viOpen                                                          */
/* Purpose:  Interface independent version of function viOpen                */
/*===========================================================================*/
ViStatus _VI_FUNC  rsOpen (ViSession sesn, ViRsrc name, ViAccessMode mode,
                           ViUInt32 timeout, ViPSession vi)
{
  ViStatus status = VI_ERROR_LIBRARY_NFOUND;
  StrctDevice* pDevice = 0;
  StrctResource* pResource = 0;
  viOpenType pFuncViOpen  = 0;
  char lowername[256];
  int i = 0, nLibId = LibIdVisa, nIntfId = VI_INTF_TCPIP;
  ViSession SessionDefaultRM = 0;
//  int nResourceHandle = 0;
  // printf ("viOpen <%s>\n",name);

  *vi = 0;

  for (i = 0; name[i] && i < 255; i++)
    lowername[i] = tolower (name[i]);
  lowername [i]=0;

  
  /* select Library depending on the selected control channel   */
  if (strstr (lowername, "pcie::"))
  {
    nLibId = LibIdPCIe;
    nIntfId = VI_INTF_PXI;
  }
  else if (strstr (lowername, "::socket") && shlIsOpen(RemoteControlLibrary[LibIdSocket]))
  {
    nLibId = LibIdSocket;
    nIntfId = VI_INTF_TCPIP;
  }  
  else if (strstr (lowername, "usb::") )
  {
    nLibId = LibIdVisa;
    nIntfId = VI_INTF_USB;
  }
  else
  {
    nLibId = LibIdVisa;
    nIntfId = VI_INTF_TCPIP;
  }

/* only now that we know the remote control channel can we call viOpenDefaultRMType */

  if (shlIsOpen(RemoteControlLibrary[nLibId]))
  {
    viOpenDefaultRMType pFuncViOpenDefaultRM = 0;
    // printf ("Required Library %s is open\n", RemoteControlLibraryName[nLibId]);


    status = VI_ERROR_NSUP_OPER;
    pFuncViOpenDefaultRM = (viOpenDefaultRMType) FunctionPointers[nLibId][FuncIdOpenDefaultRM];

    if (pFuncViOpenDefaultRM)
      status =  pFuncViOpenDefaultRM (&SessionDefaultRM);
      
  }
  else
  {
    printf ("Required Library %s NOT open\n", RemoteControlLibraryName[nLibId]);

  }

  pResource = (StrctResource*) malloc (sizeof (StrctResource));
  pResource->LibId = nLibId;
  pResource->IntfId = nIntfId;
  pResource->Data = SessionDefaultRM;

  SetResource(sesn, pResource);


  pDevice = (StrctDevice*) malloc (sizeof (StrctDevice));
  pDevice->UserData = 0;
  pDevice->EnableFastSettings = 0;
  pDevice->EnableAsyncSettings = 0;
  pDevice->LastSettingWasFast = 0;
  pDevice->Device = 0;
  pDevice->ResourceHandle = sesn; // nResourceHandle;
  
  *vi = AddDevice(pDevice);


  if (status == VI_SUCCESS)
  {
    pFuncViOpen = (viOpenType)FunctionPointers[nLibId][FuncIdOpen];
      
    if (pFuncViOpen)
    {
      ViSession vi1 = 0;
      status =  pFuncViOpen (SessionDefaultRM, name, mode,timeout, &vi1);
      if (status == VI_SUCCESS)
      {
        pDevice->Device = vi1;
      }
    }
  }

  return status;
}                                    
/*===========================================================================*/
/* Function: viClose                                                         */
/* Purpose:  Interface independent version of function viClose               */
/*===========================================================================*/
ViStatus _VI_FUNC  rsClose         (ViObject vi)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = 0;
  StrctResource* pResource= 0;
  viCloseType pFuncViClose  = 0;

  if (IsResourceHandle(vi))
  {
    int i = 0;
    pResource = GetResource(vi);
    if (pResource)
    {
      pFuncViClose = (viCloseType)FunctionPointers[pResource->LibId][FuncIdClose];

      if (pFuncViClose)
        status =  pFuncViClose (pResource->Data);

      free (pResource);
      RemoveResource(vi);
    }
    for (i = 0; i < LibIdCnt; i++)
    {
      viCloseRemoteControlLibrary (i);
    }
  }
  else 
  {
    pDevice = GetDevice(vi);
    if (pDevice)
    {
      pResource = GetResource(pDevice->ResourceHandle);
      if (pResource)
        pFuncViClose = (viCloseType)FunctionPointers[pResource->LibId][FuncIdClose];

      if (pFuncViClose)
        status =  pFuncViClose ((ViObject)pDevice->Device);

      RemoveDevice(vi);
      
      if (GetDeviceCount(pDevice->ResourceHandle) == 0)
      {
        rsClose (pDevice->ResourceHandle);
      }
      free (pDevice);

    }
  }

return status;
}                                    

/*===========================================================================*/
/* Function: viSetAttribute                                                  */
/* Purpose:  Interface independent version of function viSetAttribute        */
/*===========================================================================*/
ViStatus _VI_FUNC  rsSetAttribute  (ViObject vi, ViAttr attrName, ViAttrState attrValue)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);
  viSetAttributeType pFuncViSetAttribute  = 0;
  viFastSendControlMessageType pFuncViFastSendControlMessage = 0;

  if (pDevice)
  {  
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    pFuncViFastSendControlMessage = (viFastSendControlMessageType)FunctionPointers[pResource->LibId][FuncIdFastSendControlMessage];

    switch (attrName)
    {
      case SGS_ATTR_FAST:
        if (pFuncViFastSendControlMessage)
        {
          pDevice->EnableFastSettings = (unsigned int)attrValue;
          if (attrValue)
        	  status =  viFastSetInt32 (vi, IdDriverVersion, SgmaDriverVersion);
          else
            status = VI_SUCCESS;
        }
        else
    	    status = VI_SUCCESS; // ignore for other interfaces

        break;

      case SGS_ATTR_FASTASYNCHRONOUS:
        pFuncViFastSendControlMessage = (viFastSendControlMessageType)FunctionPointers[pResource->LibId][FuncIdFastSendControlMessage];
        if (pFuncViFastSendControlMessage)
        {
          pDevice->EnableAsyncSettings = attrValue;
          status =  pFuncViFastSendControlMessage ((ViObject)pDevice->Device, attrValue ? ControlMessageAsynchronous : ControlMessageSynchronous);
        }
        else
      	  status = VI_SUCCESS; // ignore for other interfaces
        break;

      case VI_ATTR_USER_DATA:
        pDevice->UserData = (unsigned int)attrValue;
        status = VI_SUCCESS;
        break;

      default:
        pFuncViSetAttribute = (viSetAttributeType)FunctionPointers[pResource->LibId][FuncIdSetAttribute];
        if (pFuncViSetAttribute)
        {
          status =  pFuncViSetAttribute ((ViObject)pDevice->Device, attrName, attrValue);
        }
        break;
    }

  }
  return status;
}                                    

/*===========================================================================*/
/* Function: viGetAttribute                                                  */
/* Purpose:  Interface independent version of function viGetAttribute        */
/*===========================================================================*/
ViStatus _VI_FUNC  rsGetAttribute   (ViObject vi, ViAttr attrName, void _VI_PTR attrValue)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  viGetAttributeType pFuncViGetAttribute  = 0;
  StrctResource* pResource = 0;

  if (attrName == VI_ATTR_RSRC_MANF_NAME || 
    attrName == VI_ATTR_RSRC_MANF_ID)
  {
    pResource = GetResource(vi);
    if (pResource)
      pFuncViGetAttribute = (viGetAttributeType)FunctionPointers[pResource->LibId][FuncIdGetAttribute];
    if (pFuncViGetAttribute)
    {
      status =  pFuncViGetAttribute ((ViObject)(vi), attrName, attrValue);
    }
  }
  else
  {
    StrctDevice* pDevice = GetDevice(vi);
    if (pDevice)
    {
      switch (attrName)
      {
        case SGS_ATTR_FAST:
          status = VI_SUCCESS;
          if (!pDevice->EnableFastSettings)
            *((unsigned int*) attrValue) = VI_FALSE;
          else
          {
            pResource = GetResource(pDevice->ResourceHandle);
            if (pResource)
            pFuncViGetAttribute = (viGetAttributeType)FunctionPointers[pResource->LibId][FuncIdGetAttribute];
            if (pFuncViGetAttribute)
              status =  pFuncViGetAttribute ((ViObject)(pDevice->Device), attrName, attrValue);
          }
          break;

        case SGS_ATTR_FASTASYNCHRONOUS:
            *((unsigned int*) attrValue) = pDevice->EnableAsyncSettings;
            status = VI_SUCCESS;
          break;


        case VI_ATTR_RM_SESSION:
          *((unsigned int*) attrValue) = (unsigned int)(pDevice->ResourceHandle);
          status = VI_SUCCESS;
          break;

        case VI_ATTR_USER_DATA:
          *((unsigned int*) attrValue) = pDevice->UserData;
          status = VI_SUCCESS;
          break;

        case VI_ATTR_INTF_TYPE:
        {
          pResource = GetResource(pDevice->ResourceHandle);
          if (pResource)
          {
            *((unsigned short*) attrValue) = pResource->IntfId;
            status = VI_SUCCESS;
          }
        }
        break;

        default:
          pResource = GetResource(pDevice->ResourceHandle);
          if (pResource)
            pFuncViGetAttribute = (viGetAttributeType)FunctionPointers[pResource->LibId][FuncIdGetAttribute];
          if (pFuncViGetAttribute)
          {
            status =  pFuncViGetAttribute ((ViObject)(pDevice->Device), attrName, attrValue);
          }
          break;
      }
    }
  }
  return status;
}                                    

/*===========================================================================*/
/* Function: message                                            */
/* Purpose:  send interface control message to PCIe host interface           */
/*===========================================================================*/
ViStatus _VI_FUNC  rsFastSync (ViObject vi)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);
  viFastSendControlMessageType pFuncViFastSendControlMessage = 0;

  if (pDevice && pDevice->LastSettingWasFast)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
	  if (pResource)
	    pFuncViFastSendControlMessage = (viFastSendControlMessageType)FunctionPointers[pResource->LibId][FuncIdFastSendControlMessage];
	  if (pFuncViFastSendControlMessage)
	    status =  pFuncViFastSendControlMessage ((ViObject)pDevice->Device, ControlMessageSync);
	  else
	    status = VI_SUCCESS;
  }
  return status;
}


/*===========================================================================*/
/* Function: viQueryf                                                        */
/* Purpose:  Interface independent version of function viQueryf              */
/*===========================================================================*/
ViStatus _VI_FUNCC rsQueryf        (ViSession vi, ViString writeFmt, ViString readFmt, ...)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);
  viVQueryfType pFuncViVQueryf  = 0;
  if (pDevice)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncViVQueryf = (viVQueryfType)FunctionPointers[pResource->LibId][FuncIdVQueryf];
  }
  if (pFuncViVQueryf)
  {
    ViVAList params;
    va_start(params, readFmt);
    status =  pFuncViVQueryf ((ViObject)(pDevice->Device), writeFmt, readFmt, params);
  }
  return status;
}
/*===========================================================================*/
/* Function: viPrintf                                                        */
/* Purpose:  Interface independent version of function viPrintf              */
/*===========================================================================*/
ViStatus _VI_FUNCC rsPrintf        (ViSession vi, ViString writeFmt, ...)
{
/*  printf ("viPrintf <"); */

  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);
  viVPrintfType pFuncViVPrintf  = 0;
  if (pDevice)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncViVPrintf = (viVPrintfType)FunctionPointers[pResource->LibId][FuncIdVPrintf];
    pDevice->LastSettingWasFast = 0;
  }
  if (pFuncViVPrintf)
  {
    ViVAList params;
    va_start(params, writeFmt);
    status =  pFuncViVPrintf ((ViSession)(pDevice->Device), writeFmt, params);
    /*    vprintf (writeFmt, params);
    printf (">\n"); */

  }
  return status;
}

/*===========================================================================*/
/* Function: viReadSTB                                                       */
/* Purpose:  Interface independent version of function viReadSTB             */
/*===========================================================================*/
ViStatus _VI_FUNC  rsReadSTB       (ViSession vi, ViPUInt16 stat)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);
  viReadSTBType pFuncViReadSTB  = 0;
  if (pDevice)
  {
    StrctResource*pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncViReadSTB = (viReadSTBType)FunctionPointers[pResource->LibId][FuncIdReadSTB];
    pDevice->LastSettingWasFast = 0;
  }
  if (pFuncViReadSTB)
  {
    status =  pFuncViReadSTB ((ViSession)(pDevice->Device), stat);
  }
  return status;
}


/*===========================================================================*/
/* Function: viWrite                                                          */
/* Purpose:  Interface independent version of function viWrite                */
/*===========================================================================*/
ViStatus _VI_FUNC  rsWrite         (ViSession vi, ViBuf  buf, ViUInt32 cnt, ViPUInt32 retCnt)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);
  viWriteType pFuncViWrite  = 0;
  if (pDevice)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncViWrite = (viWriteType)FunctionPointers[pResource->LibId][FuncIdWrite];
    pDevice->LastSettingWasFast = 0;
  }
  if (pFuncViWrite)
  {
    status =  pFuncViWrite (pDevice->Device, buf, cnt, retCnt);
  }
  return status;
}

/*===========================================================================*/
/* Function: viScanf                                                         */
/* Purpose:  Interface independent version of function viScanf               */
/*===========================================================================*/
ViStatus _VI_FUNCC rsScanf         (ViSession vi, ViString readFmt, ...)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);
  viVScanfType pFuncViVScanf  = 0;
  if (pDevice)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncViVScanf = (viVScanfType)FunctionPointers[pResource->LibId][FuncIdVScanf];
    pDevice->LastSettingWasFast = 0;
  }
  if (pFuncViVScanf)
  {
    ViVAList params;
    va_start(params, readFmt);
    status =  pFuncViVScanf (pDevice->Device, readFmt, params);
  }
  return status;
}
/*===========================================================================*/
/* Function: viRead                                                          */
/* Purpose:  Interface independent version of function viRead                */
/*===========================================================================*/
ViStatus _VI_FUNC  rsRead          (ViSession vi, ViPBuf buf, ViUInt32 cnt, ViPUInt32 retCnt)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);
  viReadType pFuncViRead  = 0;
  if (pDevice)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncViRead = (viReadType)FunctionPointers[pResource->LibId][FuncIdRead];
    pDevice->LastSettingWasFast = 0;
  }
  if (pFuncViRead)
  {
    status =  pFuncViRead (pDevice->Device, buf, cnt, retCnt);
  }
  return status;
}

/*===========================================================================*/
/* Function: viSetBuf                                                        */
/* Purpose:  Interface independent version of function viSetBuf              */
/*===========================================================================*/
ViStatus _VI_FUNC  rsSetBuf        (ViSession vi, ViUInt16 mask, ViUInt32 size)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);
  viSetBufType pFuncViSetBuf  = 0;
  if (pDevice)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncViSetBuf = (viSetBufType)FunctionPointers[pResource->LibId][FuncIdSetBuf];
    pDevice->LastSettingWasFast = 0;
  }
  if (pFuncViSetBuf)
  {
    status =  pFuncViSetBuf (pDevice->Device, mask, size);
  }
  return status;
}
/*===========================================================================*/
/* Function: viStatusDesc                                                    */
/* Purpose:  Interface independent version of function viStatusDesc          */
/*===========================================================================*/
ViStatus _VI_FUNC  rsStatusDesc    (ViObject vi, ViStatus stat, ViChar _VI_FAR desc[])
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);
  viStatusDescType pFuncViStatusDesc  = 0;
  if (pDevice)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncViStatusDesc = (viStatusDescType)FunctionPointers[pResource->LibId][FuncIdStatusDesc];
    pDevice->LastSettingWasFast = 0;
  }
  else
  {
    pFuncViStatusDesc = (viStatusDescType)FunctionPointers[LibIdVisa][FuncIdStatusDesc];
  }

  if (pFuncViStatusDesc)
  {
    status =  pFuncViStatusDesc ((ViObject)0, stat, desc);
  }
  return status;
}
/*===========================================================================*/
/* Function: viFastSettingSupported                                          */
/* Purpose:   determine, if register based setting is supported for a device */
/* and parameter                                                             */
/*===========================================================================*/
ViStatus _VI_FUNC  viFastSettingSupported (ViSession vi, ViUInt32 paraId, ViPUInt32 supported)
{
  ViStatus status = VI_SUCCESS;
  StrctDevice* pDevice = GetDevice(vi);
  viFastSettingSupportedType pFuncViFastSettingSupported  = 0;

  *supported = 0;
  if (pDevice)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncViFastSettingSupported = (viFastSettingSupportedType)FunctionPointers[pResource->LibId][FuncIdFastSettingSupported];
  }
  /* supported if both EnableFastSettings is set for this device
   * and device supports fast setting for this specific parameter */
  if (pFuncViFastSettingSupported && pDevice->EnableFastSettings)
  {
    status =  pFuncViFastSettingSupported (pDevice->Device, paraId, supported);
  }  
  return status;
}


/*===========================================================================*/
/* Function: viFastQuerySupported                                            */
/* Purpose:   determine, if register based query is supported for a device   */
/* and parameter                                                             */
/*===========================================================================*/
ViStatus _VI_FUNC  viFastQuerySupported (ViSession vi, ViUInt32 paraId, ViPUInt32 supported)
{
  ViStatus status = VI_SUCCESS;
  StrctDevice* pDevice = GetDevice(vi);
  viFastQuerySupportedType pFuncViFastQuerySupported  = 0;

  *supported = 0;
  if (pDevice)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncViFastQuerySupported = (viFastQuerySupportedType)FunctionPointers[pResource->LibId][FuncIdFastQuerySupported];
  }
  /* supported if both EnableFastSettings is set for this device
  * and device supports fast query for this specific parameter */
  if (pFuncViFastQuerySupported && pDevice->EnableFastSettings)
  {
    status =  pFuncViFastQuerySupported (pDevice->Device, paraId, supported);
  }  
  return status;
}

/*===========================================================================*/
/* Function: viFastSetReal64                                             */
/* Purpose:           */
/*===========================================================================*/
ViStatus _VI_FUNC  viFastSetReal64 (ViSession vi, ViUInt32 paraId, ViReal64 value)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);

  viFastSetReal64Type pFuncViFastSetReal64  = 0;

  // printf ("viFastSetReal64 Paraid = %ld, value = %f\n", paraId, value);

  if (pDevice)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncViFastSetReal64 = (viFastSetReal64Type)FunctionPointers[pResource->LibId][FuncIdFastSetReal64];
    pDevice->LastSettingWasFast = 1;
  }
  if (pFuncViFastSetReal64)
  {
    status =  pFuncViFastSetReal64 ((ViSession)(pDevice->Device), paraId, value);
  }  

  return status;
}

/*===========================================================================*/
/* Function: viFastSetInt32                                              */
/* Purpose:   */
/*===========================================================================*/
ViStatus _VI_FUNC  viFastSetInt32 (ViSession vi, ViUInt32 paraId, ViInt32 value)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);

  viFastSetInt32Type pFuncViFastSetInt32  = 0;

  // printf ("viFastSetint32 Paraid = %ld, value = %ld\n", paraId, value);
  if (pDevice)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncViFastSetInt32 = (viFastSetInt32Type)FunctionPointers[pResource->LibId][FuncIdFastSetInt32];
    pDevice->LastSettingWasFast = 1;
  }
  if (pFuncViFastSetInt32)
  {
    status =  pFuncViFastSetInt32 ((ViSession)(pDevice->Device), paraId, value);
  }  

  return status;
}

/*===========================================================================*/
/* Function: viFastSetMultiple                                              */
/* Purpose:   */
/*===========================================================================*/
ViStatus _VI_FUNC  viFastSetMultiple (ViSession vi, void* paraList, ViInt32 paraListItemCount)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);
  viFastSetMultipleType pFuncViFastSetMultiple  = 0;

//   printf ("viFastSetMultiple\n");

  if (pDevice)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncViFastSetMultiple = (viFastSetMultipleType)FunctionPointers[pResource->LibId][FuncIdFastSetMultiple];
    pDevice->LastSettingWasFast = 1;
  }
  if (pFuncViFastSetMultiple)
  {
    status =  pFuncViFastSetMultiple ((ViSession)(pDevice->Device), paraList, paraListItemCount);
  }

  return status;
}


/*===========================================================================*/
/* Function: viFastQueryReal64                                             */
/* Purpose:           */
/*===========================================================================*/
ViStatus _VI_FUNC  viFastQueryReal64 (ViSession vi, ViUInt32 paraId, ViReal64* pValue)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);

  viFastQueryReal64Type pFuncViFastQueryReal64  = 0;

  // printf ("viFastQueryReal64 Paraid = %ld, value = %f\n", paraId, value);

  if (pDevice)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncViFastQueryReal64 = (viFastQueryReal64Type)FunctionPointers[pResource->LibId][FuncIdFastQueryReal64];
    pDevice->LastSettingWasFast = 1;
  }
  if (pFuncViFastQueryReal64)
  {
    status =  pFuncViFastQueryReal64 ((ViSession)(pDevice->Device), paraId, pValue);
  }  

  return status;
}

/*===========================================================================*/
/* Function: viFastSetInt32                                              */
/* Purpose:   */
/*===========================================================================*/
ViStatus _VI_FUNC  viFastQueryInt32 (ViSession vi, ViUInt32 paraId, ViInt32* pValue)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);

  viFastQueryInt32Type pFuncViFastQueryInt32  = 0;

  // printf ("viFastQueryInt32 Paraid = %ld, value = %ld\n", paraId, value);
  if (pDevice)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncViFastQueryInt32 = (viFastQueryInt32Type)FunctionPointers[pResource->LibId][FuncIdFastQueryInt32];
    pDevice->LastSettingWasFast = 1;
  }
  if (pFuncViFastQueryInt32)
  {
    status =  pFuncViFastQueryInt32 ((ViSession)(pDevice->Device), paraId, pValue);
  }  

  return status;
}


/*===========================================================================*/
/* Function: Enumerate PCIe devices
/* Purpose:  */
/*           */
/*           */
/*           */
/*           */
/*===========================================================================*/
ViStatus _VI_FUNC viEnumerate_pcie_devices (ViInt32 vendorId, ViInt32 deviceId, ViPInt32 serialNumbers, ViPInt32 serialNumberCount)
{
  ViStatus  status = VI_ERROR_NSUP_OPER;
  viEnumeratePCIeDevicesType pFuncViEnumerate  = 0;

  viOpenRemoteControlLibrary(LibIdPCIe);
  if (shlIsOpen(RemoteControlLibrary[LibIdPCIe]))
  {
    pFuncViEnumerate = (viEnumeratePCIeDevicesType)FunctionPointers[LibIdPCIe][FuncIdEnumerateDevices];

    if (pFuncViEnumerate)
    {
      status =  pFuncViEnumerate (vendorId, deviceId, serialNumbers, serialNumberCount);
    }
    viCloseRemoteControlLibrary(LibIdPCIe);
  }
  else
  {
    printf ("Required Library %s NOT open\n", RemoteControlLibraryName[LibIdPCIe]);
  }

  if (status != VI_SUCCESS)
    *serialNumberCount = 0;

  return status;
}

/*===========================================================================*/
/* Function: Enumerate Socket devices
/* Purpose:  */
/*           */
/*           */
/*           */
/*           */
/*===========================================================================*/
ViStatus _VI_FUNC  viEnumerate_socket_devices (ViPString *info, ViPInt32 infoCount)
{
  ViStatus  status = VI_ERROR_NSUP_OPER;
  viEnumerateSocketDevicesType pFuncViEnumerate  = 0;

  viOpenRemoteControlLibrary(LibIdSocket);
  if (shlIsOpen(RemoteControlLibrary[LibIdSocket]))
  {
    pFuncViEnumerate = (viEnumerateSocketDevicesType)FunctionPointers[LibIdSocket][FuncIdEnumerateSocketDevices];

    if (pFuncViEnumerate)
    {
      status =  pFuncViEnumerate (info, infoCount);
    }
    viCloseRemoteControlLibrary(LibIdSocket);
  }
  else
  {
    printf ("Required Library %s NOT open\n", RemoteControlLibraryName[LibIdSocket]);
  }


  return status;
}

/*===========================================================================*/
/* Function: rsClear                                                        */
/* Purpose:  Interface independent version of function viClear              */
/*===========================================================================*/
ViStatus _VI_FUNC rsClear (ViSession vi)
{
  ViStatus status = VI_ERROR_NSUP_OPER;
  StrctDevice* pDevice = GetDevice(vi);
  viClearType pFuncClear  = 0;

  if (pDevice)
  {
    StrctResource* pResource = GetResource(pDevice->ResourceHandle);
    if (pResource)
      pFuncClear = (viClearType)FunctionPointers[pResource->LibId][FuncIdClear];
  }
  if (pFuncClear)
  {
    status =  pFuncClear ((ViSession)(pDevice->Device));
  }
  return status;
}


// Shared library functions



/* METHOD *********************************************************************/
/**
Loads the Shared-Library/DLL.
* @param libraryPathname: Filename
* @param resolveNow: Resolve references immediately .
* @param global: Provide symbols for other modules .
* @return true on success
*******************************************************************************/
static LIBHANDLE shlOpen(const char* libraryPathname)
{
#ifdef __linux__
  LIBHANDLE handle = dlopen(libraryPathname, RTLD_NOW);
  /*
  if (handle == 0)
  printf ("Cannot open shared library %s error: %s\n",libraryPathname, dlerror());
  else
  printf ("shlOpen 0x%x\n", handle);
  */
#else
  LIBHANDLE handle = LoadLibraryA(libraryPathname);
#endif
  return handle;
} 

/* METHOD *********************************************************************/
/**
* Test if library is open
* returns TRUE if open, else FALSE
*******************************************************************************/

static int shlIsOpen(LIBHANDLE handle)
{
  return handle != 0;
}

/* METHOD *********************************************************************/
/**
* Closes the Shared-Library (decrementing the reference counter).
* @side_effects Removes Library from memory when ref count is zero.
*******************************************************************************/

static void shlClose(LIBHANDLE handle)
{
  if (handle != 0)
  {
#ifdef __linux__
    dlclose(handle);
#else
    FreeLibrary(handle);
#endif
  }
}


/* METHOD *********************************************************************/
/**
Returns pointer to function in Shared-Library/DLL.
* @precondition Shared-Library/DLL loaded.
* @param procName: Function name
* @return Pointer to function, 0 in case of error
*******************************************************************************/
static void* shlGetProcAddress(LIBHANDLE handle, const char* procName)
{
  void* pProc = 0;
  if (handle != 0)
  {
#ifdef __linux__
    pProc = dlsym(handle, procName);
    if (pProc)
    {
      Dl_info info;
      if (0 == dladdr(pProc, &info))
        return NULL;
    }
#else
    pProc = GetProcAddress(handle, procName);
#endif
  }
  return pProc;
}


/******************************************************************************/
/* END OF FILE */
/******************************************************************************/






/*****************************************************************************/
/* END OF FILE                                                               */
/*****************************************************************************/
    
    
    
    



























