/* -*- coding: utf8 -*-                              äöüß ΔΩ        */
/* Special characters above ensure UTF-8 encoding in VisualStudio.  */
/** 
@file         \$Source: $
@copyright    (c) Rohde & Schwarz GmbH & Co. KG, Munich
@version      \$Revision: $
*
@author       %USERNAME%
@responsible  \$Author: $
*
@language     C++
*
@description  
@see          
*
@history
*  \$Log: $
*
*******************************************************************************
******************************************************************************/

#ifndef VISAABSTRACTION_H
#define VISAABSTRACTION_H

/* INCLUDE FILES *************************************************************/

#include <visa.h>
/* FORWARD DECLARATIONS ******************************************************/

/* CONSTANT DECLARATIONS *****************************************************/

/* CLASS DECLARATIONS ********************************************************/

/* INLINE METHODS ************************************************************/

/* TEMPLATE METHODS **********************************************************/

/* OPERATORS *****************************************************************/

/* TYPE DECLARATIONS *********************************************************/

enum VISA_MANUFACTURER
{
  VISA_MANUFACTURER_UNKNOWN,    
  VISA_MANUFACTURER_NI,
  VISA_MANUFACTURER_AGILENT,
  VISA_MANUFACTURER_RS
};
#include "visa.h"


///* Visa compatible functions */
ViStatus _VI_FUNC  rsOpenDefaultRM (ViPSession vi);
//
ViStatus _VI_FUNC  rsOpen          (ViSession sesn, ViRsrc name, ViAccessMode mode,
                                    ViUInt32 timeout, ViPSession vi);
//
//
//
ViStatus _VI_FUNC  rsClose         (ViObject vi);
ViStatus _VI_FUNC  rsSetAttribute  (ViObject vi, ViAttr attrName, ViAttrState attrValue);
ViStatus _VI_FUNC  rsGetAttribute  (ViObject vi, ViAttr attrName, void* attrValue);
ViStatus _VI_FUNC  rsFastSync      (ViObject vi);
ViStatus _VI_FUNCC rsQueryf        (ViSession vi, ViString writeFmt, ViString readFmt, ...);
ViStatus _VI_FUNCC rsPrintf        (ViSession vi, ViString writeFmt, ...);
ViStatus _VI_FUNC  rsReadSTB       (ViSession vi, ViPUInt16 status);
ViStatus _VI_FUNC  rsWrite         (ViSession vi, ViBuf  buf, ViUInt32 cnt, ViPUInt32 retCnt);
ViStatus _VI_FUNCC rsScanf         (ViSession vi, ViString readFmt, ...);
ViStatus _VI_FUNC  rsRead          (ViSession vi, ViPBuf buf, ViUInt32 cnt, ViPUInt32 retCnt);
ViStatus _VI_FUNC  rsSetBuf        (ViSession vi, ViUInt16 mask, ViUInt32 size);
ViStatus _VI_FUNC  rsStatusDesc    (ViObject vi, ViStatus status, ViChar _VI_FAR desc[]);
ViStatus _VI_FUNC  rsClear         (ViSession vi);

/* Entensions for fast parameter settings */
#if defined(__cplusplus) || defined(__cplusplus__)
extern "C" {
#endif

  ViStatus _VI_FUNC  viFastSettingSupported (ViSession vi, ViUInt32 paraId, ViPUInt32 supported);
  ViStatus _VI_FUNC  viFastSetReal64 (ViSession vi, ViUInt32 paraId, ViReal64 value);
  ViStatus _VI_FUNC  viFastSetInt32 (ViSession vi, ViUInt32 paraId, ViInt32 value);
  ViStatus _VI_FUNC  viFastSetMultiple (ViSession vi, void* paraList, ViInt32 paraListItemCount);
  ViStatus _VI_FUNC  viFastSendControlMessage (ViSession vi, ViInt32 message);
  ViStatus _VI_FUNC  viEnumerate_pcie_devices   (ViInt32 vendorId, ViInt32 deviceId, ViPInt32 serialNumbers, ViPInt32 serialNumberCount);
  ViStatus _VI_FUNC  viEnumerate_socket_devices (ViPString *info, ViPInt32 infoCount);

  ViStatus _VI_FUNC  viFastQuerySupported (ViSession vi, ViUInt32 paraId, ViPUInt32 supported);
  ViStatus _VI_FUNC  viFastQueryReal64 (ViSession vi, ViUInt32 paraId, ViReal64* pValue);
  ViStatus _VI_FUNC  viFastQueryInt32 (ViSession vi, ViUInt32 paraId, ViInt32* pValue);


#if defined(__cplusplus) || defined(__cplusplus__)
}
#endif
#define SGS_ATTR_FAST                   0x1FFF0000
#define SGS_ATTR_FASTASYNCHRONOUS       0x1FFF0001

typedef enum  {PARATYPE_INT32, PARATYPE_REAL64} PARATYPE ;


typedef struct
{
  unsigned int      Id;
  PARATYPE          Type;
  unsigned char*    pData;
} ParaItem;

#endif /* VISAABSTRACTION_H */
/*****************************************************************************/
/* END OF FILE                                                               */
/*****************************************************************************/
